import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudDcsProductV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1#id DataOpentelekomcloudDcsProductV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1#spec_code DataOpentelekomcloudDcsProductV1#spec_code}
    */
    readonly specCode?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1 opentelekomcloud_dcs_product_v1}
*/
export declare class DataOpentelekomcloudDcsProductV1 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opentelekomcloud_dcs_product_v1";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_product_v1 opentelekomcloud_dcs_product_v1} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudDcsProductV1Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudDcsProductV1Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _specCode?;
    get specCode(): string;
    set specCode(value: string);
    resetSpecCode(): void;
    get specCodeInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
