import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudIdentityProjectsV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_projects_v3#id DataOpentelekomcloudIdentityProjectsV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataOpentelekomcloudIdentityProjectsV3Projects {
}
export declare function dataOpentelekomcloudIdentityProjectsV3ProjectsToTerraform(struct?: DataOpentelekomcloudIdentityProjectsV3Projects): any;
export declare class DataOpentelekomcloudIdentityProjectsV3ProjectsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataOpentelekomcloudIdentityProjectsV3Projects | undefined;
    set internalValue(value: DataOpentelekomcloudIdentityProjectsV3Projects | undefined);
    get description(): string;
    get domainId(): string;
    get enabled(): cdktf.IResolvable;
    get isDomain(): cdktf.IResolvable;
    get name(): string;
    get parentId(): string;
}
export declare class DataOpentelekomcloudIdentityProjectsV3ProjectsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataOpentelekomcloudIdentityProjectsV3ProjectsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_projects_v3 opentelekomcloud_identity_projects_v3}
*/
export declare class DataOpentelekomcloudIdentityProjectsV3 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opentelekomcloud_identity_projects_v3";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/identity_projects_v3 opentelekomcloud_identity_projects_v3} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudIdentityProjectsV3Config = {}
    */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudIdentityProjectsV3Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projects;
    get projects(): DataOpentelekomcloudIdentityProjectsV3ProjectsList;
    get region(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
