import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpentelekomcloudLbMemberIdsV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#id DataOpentelekomcloudLbMemberIdsV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#pool_id DataOpentelekomcloudLbMemberIdsV2#pool_id}
    */
    readonly poolId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2#region DataOpentelekomcloudLbMemberIdsV2#region}
    */
    readonly region?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2 opentelekomcloud_lb_member_ids_v2}
*/
export declare class DataOpentelekomcloudLbMemberIdsV2 extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opentelekomcloud_lb_member_ids_v2";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_member_ids_v2 opentelekomcloud_lb_member_ids_v2} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpentelekomcloudLbMemberIdsV2Config
    */
    constructor(scope: Construct, id: string, config: DataOpentelekomcloudLbMemberIdsV2Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ids(): string[];
    private _poolId?;
    get poolId(): string;
    set poolId(value: string);
    get poolIdInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
